	uniform mat4 uMVPMatrix;
	//图页起点
	uniform vec3 vStart;
	//旋转中心坐标
	uniform vec3 vCenter;
	//旋转角度：弧度
	uniform float fAngle;
	//圆顶点索引
	attribute float fCornerIndex;
	//圆顶点半径
	uniform float fRadius;
	//圆中心坐标
	uniform vec3 vCircleCenter;
	//圆顶点个数
	uniform int iCount;
	
	void main(){ 
		float angle = float(6.2831852) / float(iCount) * fCornerIndex;
		vec3 corner = vCircleCenter;
		corner.x = fRadius * cos(angle) + vCircleCenter.x;
		corner.y = fRadius * sin(angle) + vCircleCenter.y;

		if(abs(fAngle) < float(0.01)){
			//没有旋转
			gl_Position = uMVPMatrix * vec4(corner + vStart,1);
		}else{
			//旋转
			vec3 p1 = corner + vStart - vCenter;
			float len = sqrt(p1.x*p1.x+p1.y*p1.y);
			if(len == float(0)){
				// 坐标在屏幕中心时不用旋转
				gl_Position = uMVPMatrix * vec4(corner + vStart,1);
			}else{
				float rotate = atan(p1.y, p1.x);
				if (rotate < float(0)) {
					rotate = rotate + float(6.28) + fAngle;
				} else {
					rotate = rotate + fAngle;
				}
				p1.x = len * cos(rotate);
				p1.y = len * sin(rotate);
				gl_Position = uMVPMatrix * vec4(p1 + vCenter,1);
			}
		}
	}
