	uniform mat4 uMVPMatrix;
	//顶点buffer
	attribute vec3 vPosition;
	//双线或点的偏移buffer
	attribute vec3 vOffset;
	//图页起点
	uniform vec3 vStart;
	//放大率
	uniform float fZoom;
	//旋转中心坐标
	uniform vec3 vCenter;
	//旋转角度：弧度
	uniform float fAngle;
	//纹理窗口buffer
	attribute vec2 textureCoord;
	varying vec2 vTexCoor;
	//点数据的旋转类型：0，点永远北上；1，点随地图旋转
	uniform int iType;
	
	void main(){ 
		vec3 offset = vOffset * fZoom;
		if(abs(fAngle) < float(0.01)){
			//没有旋转
			gl_Position = uMVPMatrix * vec4(offset + vPosition + vStart,1);
		}else{
			//旋转
			vec3 p1 = vPosition + vStart - vCenter;
			if(iType == 1){
				p1 = p1 + offset;
			}
			float len = sqrt(p1.x*p1.x+p1.y*p1.y);
			if(len == float(0)){
				// 坐标在屏幕中心时不用旋转
				gl_Position = uMVPMatrix * vec4(offset + vPosition + vStart,1);
			}else{
				float rotate = atan(p1.y, p1.x);
				if (rotate < float(0)) {
					rotate = rotate + float(6.28) + fAngle;
				} else {
					rotate = rotate + fAngle;
				}
				p1.x = len * cos(rotate);
				p1.y = len * sin(rotate);
				if(iType == 0){
					p1 = p1 + offset;
				}
				
				gl_Position = uMVPMatrix * vec4(p1 + vCenter,1);
			}
		}
		vTexCoor = textureCoord;
	}
